
#include "kolibri.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

#include "car_01.h"
#include "car_02.h"
#include "donkey_01.h"
#include "donkey_02.h"

int start, paintbg;
int dox, doy;
int drx, dry;

int drn, don;

int speed;


void game_start()
{
drx = -1;
dry = 0;
doy = random(40)+130;

dox = random(1);
if (0 == dox)
	dox--;

drn = don = 0;
paintbg = 1;

speed = 0;

kol_sleep(25);
}


void screen_back()
{

char num[2];
num[1]=0;

kol_paint_bar(0, 0, 320, 200, 0x888888);

kol_paint_bar(6, 6, 97-6, 195-6, 0x00a8a8);
kol_paint_bar(183, 6, 305-183, 195-6, 0x00a8a8);

kol_paint_string(30, 30, "Donkey", 0x80eeeeee);
kol_paint_string(200, 30, "Driver", 0x80eeeeee);

num[0] = don+'0';
kol_paint_string(30, 40, num, 0x80eeeeee);

num[0] = drn/10+'0';
kol_paint_string(200, 40, num, 0x80eeeeee);


kol_paint_string(200, 120, "Press Space", 0x80eeeeee);
kol_paint_string(200, 130, "Bar to switch", 0x80eeeeee);
kol_paint_string(200, 140, "lanes", 0x80eeeeee);
kol_paint_string(200, 160, "Press ESC", 0x80eeeeee);
kol_paint_string(200, 170, "to exit", 0x80eeeeee);

kol_paint_line(100, 0, 100, 199, 0xffffff);
kol_paint_line(180, 0, 180, 199, 0xffffff);

paintbg = 0;
}



void screen_draw()
{

int y;

if (don > 9)
	{
	kol_screen_wait_rr();
	kol_paint_bar(0, 0, 320, 200, 0x880000);
	kol_paint_string(30, 30, "G A M E    O V E R", 0x80ffffff);
	kol_sleep(150);
	game_start();
	start = 1;
	}

if (drn > 90)
	{
	kol_screen_wait_rr();
	kol_paint_bar(0, 0, 320, 200, 0x000088);
	kol_paint_string(30, 30, "C O N G R A T U L A T I O N S  ! ! !", 0x80ffffff);
	kol_sleep(150);
	game_start();
	start = 1;
	}

if (drn > 10)
	speed = 1;

if (drn > 85)
	speed = 2;

kol_screen_wait_rr();

if (start)
	{
	if (!paintbg)
		return;
	kol_paint_bar(0, 0, 320, 200, 0x888888);
	kol_paint_string(30, 30, "D O N K E Y", 0x8000ee00);
	kol_paint_string(30, 40, "version 0.5", 0x8000ee00);
	kol_paint_string(30, 50, "remake for KolibriOS by O.Bogomaz", 0x8000ee00);
	kol_paint_string(30, 150, "Press space bar to continue", 0x80eeee00);
	kol_paint_end();
	paintbg = 0;
	return;
	}

if (paintbg)
	screen_back();
else 
	kol_paint_bar(102, 0, 180-102, 200, 0x888888);

for (y=10; y<180; y+=20)
	kol_paint_line(140, y-10*(doy%2), 140, y+10-10*(doy%2), 0xffffff);

doy-=5;
if (doy < -50)
	{

	dox = random(1);
	if (0 == dox)
		dox--;

	doy = random(40)+130;
	dry += 10;
	drn++;
	if (0 == drn%10)
		dry = 0;
	paintbg = 1;
	}

if ((drx == dox)&&(dry > doy-14)&&(dry < doy+14))
	{
	kol_paint_string(30, 120, "BOOM!", 0x80eeeeee);
	don++;
	dry = 0;
	drn /= 10;
	drn *= 10; 
	for (y = 0; y<2; y++)
		{
		kol_sleep(8);
		kol_screen_wait_rr();
		screen_back();
		kol_paint_image(140-13-(y+1)*20, 120-dry+(y+1)*20, 13, 34, CAR_01);
		kol_paint_image(120+(y+3)*20, 120-dry+(y+1)*20, 13, 34, CAR_02);
		kol_paint_image(140-17-(y+1)*20, 120-(y+1)*20, 17, 17, DONKEY_01);
		kol_paint_image(140+(y+3)*20, 120-(y+1)*20, 13, 17, DONKEY_02);
		}

	dox = random(1);
	if (0 == dox)
		dox--;

	doy = random(40)+130;
	paintbg = 1;
	}

kol_paint_image(140-13-drx*20, 130-dry, 13, 34, CAR_01);
kol_paint_image(140-drx*20, 130-dry, 13, 34, CAR_02);

kol_paint_image(140-17-dox*20, 130-doy, 17, 17, DONKEY_01);
kol_paint_image(140-dox*20, 130-doy, 13, 17, DONKEY_02);

}



void wnd_draw()
{
kol_paint_start();
kol_wnd_define(250, 150, 320, 200, 0x888888);
screen_draw();
kol_paint_end();
}




void kol_main()
{

unsigned event;
unsigned key;

srand(kol_system_time_get()<<8);
start = 1;
paintbg = 1;

speed = 0;

wnd_draw();

for (;;)
	{

	kol_sleep(6-speed);
	screen_draw();
	event = kol_event_check();

	switch (event)
		{
		case 1:
			paintbg = 1;
			wnd_draw();
			break;

		case 2:
			key = (kol_key_get() & 0xff00)>>8;
			if (start && (32==key))
				{
				start = 0;
				game_start();
				screen_draw();
				break;
				}

			if (start && (27==key))
				{
				kol_exit();
				return;
				}

			if (27 == key)
				{
				start = 1;
				paintbg = 1;
				break;
				}
			if (32 == key)
				{
				drx *= -1;
				screen_draw();
				}
			break;

		case 3:
			if ( 1 == (kol_btn_get() & 0xff00)>>8 )
				kol_exit();
			break;

		};
	}

}
